/*
 * ValidateAddress.java
 *
 * Copyright 2014 the curewallet.org.
 * http://www.curewallet.org/
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND,
 * either express or implied. See the License for the specific language
 * governing permissions and limitations under the License.
 */
package org.curewallet.lib.api;

import org.curewallet.lib.api.result.ValidateAddressResult;
import org.curewallet.lib.jsonrpc.JsonRPCClient;

/**
 * validateaddress<br>
 * ウォレットアドレスの情報を取得するためのAPIです。
 * 
 * @author Nezumi Kozo
 * @since 1.0
 */
public interface ValidateAddress extends CoinAPI {

	/**
	 * ウォレットアドレスの情報を取得します。
	 * @param jsonRPCClient
	 * @param address
	 * @return
	 * @throws CoinAPIException
	 * @since 1.0
	 */
	public ValidateAddressResult call(JsonRPCClient jsonRPCClient, String address) throws CoinAPIException;

}
